export function whenClassIsReady(Source, context) {
    let whenReady = context.updatesInProgress && context.updatesInProgress.get(Source);
    if (whenReady && !whenReady.resultRegistered) {
        context.updatesInProgress.set(Source, whenReady = whenReady.then(newProgress => {
            if (context.updatesInProgress.get(Source) == whenReady) {
                context.updatesInProgress.delete(Source);
            }
            if (newProgress) {
                mergeProgress(context, newProgress);
            }
        }));
        whenReady.resultRegistered = true;
    }
    return whenReady;
}
export function mergeProgress(target, source) {
    if (source.updatesInProgress) {
        for (const [Source, promise] of source.updatesInProgress) {
            registerProcessing(target, Source, promise);
        }
    }
}
export function registerProcessing(target, Source, promise) {
    if (!target.updatesInProgress) {
        target.updatesInProgress = new Map();
    }
    target.updatesInProgress.set(Source, promise);
}
export const DEFAULT_CONTEXT = {
    updatesInProgress: new Map()
};
//# sourceMappingURL=UpdateProgress.js.map