/// <reference types="node" />
import ArrayLikeIterable from '../util/ArrayLikeIterable';
export interface Database {
    getSync(id: any, asBuffer?: any): any;
    get(id: any): Promise<any>;
    putSync(id: any, value: any): void;
    put(id: any, value: any): void;
    removeSync(id: any): void;
    remove(id: any): void;
    iterable(options: IterableOptions): ArrayLikeIterable;
    batch(operations: OperationsArray): void;
    close(): void;
    clear(): void;
    transaction(executor: () => void): void;
}
export interface IterableOptions {
    start: Buffer;
    end?: Buffer;
    values?: boolean;
    reverse?: boolean;
    valueAsBuffer?: boolean;
    waitForInitialization?: boolean;
    limit?: number;
}
export interface OperationsArray extends Array<{
    type: string;
    key: any;
    value?: any;
}> {
    byteCount?: number;
}
